
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 86
#define YY_END_OF_BUFFER 87
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[409] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   87,   85,   84,   84,   85,   85,   85,   37,
       61,   85,   85,   85,   85,   66,   85,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   38,   39,
       60,   84,   61,   85,   85,   85,   66,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   77,   76,
       76,   77,   77,   67,   69,   68,   74,   74,   74,   49,
       49,   48,   47,   46,   36,   34,   34,   36,   36,   36,
       11,   13,   36,   15,   16,    9,   12,    8,   14,   10,
       30,   30,    3,   22,    7,   23,   35,   35,   35,   35,

       35,   35,   35,    0,    0,   83,    0,    0,   65,   65,
       65,   63,   71,   66,    0,   66,   66,   66,   66,    1,
       66,   66,   66,   66,   66,   66,   66,   66,    0,    0,
        0,    0,    0,    0,    0,    0,   65,    0,    0,    0,
       66,   66,   66,   66,   66,   66,   66,    1,   66,   66,
       66,   66,   66,   66,   66,   66,    0,   70,    0,    0,
       75,   68,   74,   74,   73,   50,   46,   20,    0,   33,
        0,    0,   31,    0,   32,    0,   72,   28,    0,   30,
       18,   21,   17,   19,   35,   35,   35,   35,    4,   35,
       35,    0,   79,    0,   78,    0,    0,   81,    0,   65,

       65,   62,   62,   63,   64,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   43,   66,   66,   66,   59,    0,
       82,   65,    0,    0,   59,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   43,   66,   66,   66,    0,    0,
        0,   31,    0,    0,   29,    5,   35,    6,   35,   35,
        0,   80,   65,   62,   62,   64,   66,   66,   42,   66,
       66,   66,   66,   66,   66,   41,   66,   66,    0,    0,
        0,   66,   66,   42,   66,   66,   66,   66,   66,   66,
       41,   66,   66,    0,    0,    0,    0,    0,   35,   35,
        2,   66,   66,   66,   66,   66,   66,   66,   66,   66,

       44,    0,    0,   66,   66,   66,   66,   66,   66,   66,
       66,   66,   44,    0,   35,   35,   66,   66,   66,    0,
       55,   66,   66,   66,   66,   66,    0,    0,   66,   66,
       66,   66,   66,   66,   66,   66,   35,   35,    0,   57,
       66,    0,   51,    0,   56,   66,   66,   40,   66,    0,
       58,   66,   66,   66,   40,   66,   35,   35,   66,   66,
       66,   66,   66,   66,   66,   66,   24,   35,    0,   54,
       66,    0,   53,    0,   52,   66,   35,   35,   66,   66,
       25,   26,   66,   66,   35,   66,   66,   27,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,

       66,   66,   66,   66,   66,   66,   45,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   39,   40,   41,   42,   43,   44,
       39,   45,   46,   47,   48,   49,   50,   51,   52,   39,
        1,   53,    1,   29,   54,    1,   55,   56,   57,   58,

       59,   60,   61,   62,   63,   39,   39,   64,   65,   66,
       67,   68,   39,   69,   70,   71,   72,   49,   73,   74,
       75,   39,   76,   29,   77,   78,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[79] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,    1,   13,
       13,   14,   15,   16,    1,   17,    1,   18,    1,   19,
       20,   21,   21,   21,   19,   22,   22,   22,   22,   22,
       22,   23,   22,   22,   23,   22,   23,   22,   24,   22,
       25,   22,    6,   26,   19,   20,   21,   21,   21,   19,
       22,   22,   22,   22,   22,   23,   22,   22,   23,   22,
       23,   22,   22,   25,   22,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[475] =
    {   0,
        0,   78,  156,    0,  232,  233,  235,  238,  230,  235,
      257,    0, 1188, 2900, 2900, 2900,    0, 1179,    0, 2900,
     2900, 1162,  230,    0, 1134,    0,    0,  304,  295,  299,
      300,  306,  300,  299,  297,  312,  315,  309, 2900, 2900,
        0,  374,  334, 1131,  397,  365,  462,  413,  506,  313,
      317,  397,  327,  350,  393,  438,  428,  402, 2900, 2900,
     2900,  390, 1140, 2900, 2900,    0, 1137, 1045, 1018,    0,
     2900, 2900, 2900,  426, 2900, 2900, 2900, 1008,  408,  410,
     2900, 2900,  326, 2900, 2900, 2900, 2900, 2900, 2900, 1019,
      438,  432, 2900,  227, 1005, 1000,  400,    0,  447,  448,

      448,  454,  328,  496,  945, 2900,  573,  500,    0,  529,
      344,    0, 2900,    0,  923,  463,  469,  467,  475,    0,
      485,  505,  505,  501,  496,  501,  504,  500,  650,  534,
      930,  934,  541,    0,  637,  657,  673,  819,  384,  687,
      706,  648,  719,  760,  648,  647,  695,  500,  700,  698,
      720,  682,  625,  718,  723,  746,  443, 2900,  435,  810,
     2900,    0,  806,  703, 2900,    0,  737, 2900,  699, 2900,
      775,    0,    0,  659, 2900,  777, 2900,  642,    0,  779,
     2900, 2900, 2900, 2900,    0,  697,  706,  739,    0,  753,
      756,  800, 2900,  653, 2900,  851,  816,  830,  563,  836,

      548,    0,    0,    0,    0,  767,  765,  787,  791,  764,
      776,  886,  887,  791,    0,  888,  889,  900,    0,  933,
     2900,  936,  709,  711,  946,  987, 1037,  907,  919,  897,
      901,  942,  946,  924,  906,  947,  951,  928, 1007,  821,
        0,    0,  824,    0, 2900,    0,  935,    0,  951,  957,
      537, 2900,  489,    0,    0,    0,  975,  975,    0,  994,
      985,  998,  994, 1006,  997,    0, 1004,  998,  974,  976,
     1031, 1027, 1025, 1018, 1044, 1030, 1038, 1034, 1047, 1039,
     1040, 1052, 1065, 1099,  964,    0, 1009,    0, 1083, 1068,
        0, 1076, 1091, 1083, 1122, 1094, 1084, 1085, 1097, 1102,

        0, 1071,  502, 1095, 1103, 1104, 1160, 1121, 1123, 1114,
     1141, 1140, 1131, 1076, 1133, 1132, 1195, 1137, 1210, 1213,
     2900, 1216, 1172, 1134, 1138, 1161,  552,  482, 1231, 1181,
     1234, 1237, 1199, 1208, 1211, 1214, 1182,  756, 1260, 2900,
     1179, 1263, 2900, 1284, 2900, 1233, 1014,    0, 1236,  464,
      432, 1227, 1254, 1253, 1206, 1256, 1246, 1256, 1306, 1268,
     1309, 1330, 1333, 1284, 1336, 1347,  366, 1256, 1353, 2900,
     1277, 1358, 2900, 1364, 2900, 1331, 1306, 1316, 1324, 1329,
        0,  288, 1332, 1334, 1326, 1346, 1348,    0, 1331, 1366,
     1351, 1356, 1339, 1374, 1352, 1373, 1366, 1381, 1382, 1383,

     1389, 1391, 1383, 1388,  233, 1418, 2900, 2900, 1488, 1514,
     1540, 1566, 1592, 1600, 1625, 1651, 1669, 1683, 1707, 1725,
     1743, 1768, 1788, 1806, 1832, 1858, 1873, 1899, 1925, 1951,
     1973, 1998, 2012, 2038, 2064, 2084, 2105, 2130, 2153, 2174,
     2193, 2219, 2240, 2264, 2279, 2305, 2331, 2357, 2378, 2385,
     2406, 2432, 2453, 2466, 2475, 2501, 2527, 2553, 2579, 2605,
     2631, 2657, 2683, 2701, 2723, 2745, 2766, 2785, 2811, 2825,
     2834, 2843, 2852, 2873
    } ;

static yyconst flex_int16_t yy_def[475] =
    {   0,
      408,  408,  408,    3,  409,  409,  410,  410,  411,  411,
      408,   11,  408,  408,  408,  408,  412,  413,  414,  408,
      408,  408,  415,  415,  416,  417,  418,  417,  417,  417,
      417,  417,  417,  417,  417,  417,  417,  417,  408,  408,
      415,  419,  420,  421,  422,  423,  424,  424,  424,   49,
       49,   49,   49,   49,   49,   49,   49,   49,  408,  408,
      408,  425,  426,  408,  408,  427,  428,  428,  408,  429,
      408,  408,  408,  408,  408,  408,  408,  408,  430,  431,
      408,  408,  432,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  433,  433,  433,  433,

      433,  433,  433,  412,  413,  408,  408,  408,  415,  415,
      434,  435,  408,  417,  418,  417,  417,  417,  417,  417,
      417,  417,  417,  417,  417,  417,  417,  417,  419,  420,
      421,  436,  420,  437,  408,  421,  438,  436,  436,  439,
      440,  417,  441,  441,  144,  144,  144,  144,  144,  144,
      144,  144,  144,  144,  144,  144,  442,  408,  443,  444,
      408,  445,  446,  446,  408,  447,  408,  408,  448,  408,
      449,  450,  451,  452,  408,  453,  408,  408,  454,  408,
      408,  408,  408,  408,  455,  455,  455,  455,  455,  455,
      455,  408,  408,  456,  408,  408,  408,  408,  457,  458,

      459,  460,  461,  462,  463,  464,  464,  464,  464,  464,
      464,  464,  464,  464,  464,  464,  464,  464,  465,  408,
      408,  458,  408,  466,  467,  468,  468,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  469,  408,
      470,  451,  408,  471,  408,  455,  455,  455,  455,  455,
      457,  408,  459,  460,  461,  463,  464,  464,  464,  464,
      464,  464,  464,  464,  464,  464,  464,  464,  466,  466,
      466,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  469,  408,  472,  408,  473,  455,  455,
      455,  464,  464,  464,  464,  464,  464,  464,  464,  464,

      464,  408,  408,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  469,  455,  455,  464,  464,  464,  408,
      408,  464,  464,  464,  464,  464,  408,  474,  227,  227,
      227,  227,  227,  227,  227,  227,  455,  455,  408,  408,
      464,  408,  408,  408,  408,  464,  464,  464,  464,  474,
      474,  227,  227,  227,  227,  227,  455,  455,  464,  464,
      464,  464,  227,  227,  227,  227,  455,  455,  408,  408,
      464,  408,  408,  408,  408,  227,  455,  455,  464,  227,
      455,  455,  464,  227,  455,  464,  227,  455,  464,  227,
      464,  227,  464,  227,  464,  227,  464,  227,  464,  227,

      464,  227,  464,  227,  464,  227,  408,    0,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408
    } ;

static yyconst flex_int16_t yy_nxt[2979] =
    {   0,
       14,   15,   16,   15,   17,   14,   18,   19,   14,   20,
       14,   14,   14,   21,   22,   14,   23,   24,   25,   26,
       26,   26,   27,   14,   14,   14,   24,   24,   24,   28,
       26,   29,   26,   30,   26,   31,   26,   32,   26,   26,
       33,   26,   26,   34,   35,   36,   37,   38,   26,   26,
       26,   26,   14,   26,   28,   26,   29,   26,   30,   26,
       31,   26,   32,   26,   33,   26,   26,   34,   35,   36,
       37,   38,   26,   26,   26,   39,   40,   41,   14,   42,
       16,   42,   17,   14,   18,   19,   14,   20,   14,   14,
       14,   43,   44,   14,   45,   24,   25,   26,   26,   26,

       46,   14,   14,   14,   24,   24,   24,   47,   48,   49,
       48,   50,   48,   51,   48,   52,   48,   48,   53,   48,
       48,   54,   55,   56,   57,   58,   48,   48,   48,   48,
       14,   26,   47,   48,   49,   48,   50,   48,   51,   48,
       52,   48,   53,   48,   48,   54,   55,   56,   57,   58,
       48,   48,   48,   39,   40,   41,   59,   60,   61,   60,
       59,   62,   63,   59,   59,   59,   59,   59,   64,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   65,   59,   59,   59,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,

       66,   66,   66,   66,   66,   66,   66,   66,   59,   59,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   66,   66,   66,   66,   66,   66,
       66,   59,   59,   59,   68,   68,   71,   71,   71,   71,
       71,   71,   73,  110,  407,   69,   69,   73,  111,   74,
       74,   74,  181,  182,   74,   74,   74,   75,   76,   77,
       76,   78,   79,   75,   80,   81,   82,   83,   84,   85,
       86,   87,   88,   89,   75,   90,   91,   92,   92,   75,
       93,   94,   95,   96,   75,   75,   97,   98,   99,   98,
       98,   98,   98,   98,   98,   98,   98,   98,  100,  101,

       98,   98,  102,  103,   98,   98,   98,   98,   98,   75,
       75,   97,   98,   99,   98,   98,   98,   98,   98,   98,
       98,   98,  100,  101,   98,   98,  102,  103,   98,   98,
       98,   98,   75,   75,   75,  116,  175,  117,  118,  119,
      120,  385,  122,  123,  124,  125,  203,  121,  127,  134,
      128,  134,  146,  135,  135,  143,  147,  109,  126,  143,
      116,  117,  118,  119,  191,  120,  122,  123,  124,  150,
      125,  121,  138,  127,  128,  129,  146,  129,  176,  143,
      147,  139,  126,  143,  115,  115,  115,  223,  131,  191,
      131,  408,  143,  150,  151,  158,  132,  109,  109,  224,

      109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
      110,  109,  109,  170,  172,  111,  143,  172,  151,  377,
      109,  109,  109,  109,  109,  109,  133,  114,  141,  114,
      134,  148,  142,  142,  114,  143,  114,  351,  149,  143,
      152,  186,  159,  156,  143,  167,  167,  167,  158,  109,
      109,  180,  180,  180,  239,  239,  148,  178,  178,  143,
      171,  155,  149,  143,  152,  186,  114,  156,  143,  351,
      143,  153,  109,  109,  109,  133,  114,  141,  114,  134,
      143,  142,  142,  114,  154,  114,  155,  351,  179,  187,
      188,  252,  189,  144,  143,  159,  153,  192,  193,  192,

      190,  197,  198,  197,  143,  327,  199,  328,  154,  206,
      207,  179,  208,  187,  188,  114,  189,  209,  144,  133,
      114,  141,  114,  134,  190,  142,  142,  114,  210,  114,
      200,  198,  200,  206,  207,  201,  208,  211,  212,  252,
      214,  209,  215,  216,  217,  218,  143,  213,  145,  134,
      252,  134,  210,  135,  135,  327,  134,  328,  134,  114,
      135,  135,  211,  212,  214,  252,  215,  216,  217,  218,
      143,  213,  145,  194,  194,  195,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,

      194,  194,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  194,  194,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  194,  194,
      194,  129,  134,  129,  134,  195,  135,  135,  220,  221,
      220,  178,  178,  141,  131,  134,  131,  142,  142,  175,
      408,  235,  132,  109,  222,  221,  222,  109,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  109,  109,  227,
      223,  109,  228,  143,  143,  235,  109,  109,  109,  109,

      109,  109,  224,  139,  170,  164,  115,  115,  115,  205,
      219,  176,  223,  227,  269,  270,  228,  143,  143,  219,
      114,  234,  114,  219,  224,  109,  109,  114,  143,  246,
      231,  219,  133,  114,  141,  114,  134,  229,  142,  142,
      114,  143,  114,  230,  143,  234,  143,  247,  109,  109,
      109,  171,  143,  232,  246,  231,  167,  167,  167,  114,
      236,  229,  233,  237,  143,  143,  143,  230,  143,  143,
      143,  247,  114,  133,  114,  141,  114,  134,  232,  142,
      142,  114,  249,  114,  236,  248,  233,  237,  143,  250,
      143,  238,  143,  143,  240,  240,  243,  243,  180,  180,

      180,  192,  193,  192,  257,  358,  226,  249,  164,  248,
      258,  261,  161,  114,  250,  238,  143,  197,  198,  197,
      259,  260,  199,  262,  265,  241,  408,  244,  358,  257,
      226,  197,  198,  197,  258,  261,  199,  200,  198,  200,
      285,  285,  201,  287,  287,  259,  260,  262,  241,  265,
      244,  194,  194,  195,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,

      196,  196,  196,  194,  194,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  194,  194,  194,  263,
      264,  266,  267,  268,  220,  221,  220,  222,  221,  222,
      274,  138,  143,  408,  276,  205,  143,  106,  277,  275,
      219,  143,  143,  263,  264,  266,  267,  280,  268,  219,
      114,  283,  114,  219,  143,  274,  143,  114,  276,  143,
      143,  219,  277,  143,  275,  143,  143,  269,  270,  408,
      408,  289,  280,  169,  169,  278,  283,  143,  143,  279,
      281,  143,  143,  143,  282,  290,  143,  143,  291,  114,

      133,  114,  141,  114,  134,  289,  142,  142,  114,  278,
      114,  143,  158,  279,  281,  143,  143,  292,  282,  290,
      143,  293,  291,  294,  272,  184,  284,  284,  174,  174,
      183,  295,  177,  168,  302,  408,  165,  296,  297,  298,
      114,  292,  299,  300,  301,  293,  303,  164,  294,  272,
      133,  114,  141,  114,  134,  295,  142,  142,  114,  159,
      114,  296,  297,  143,  298,  361,  299,  300,  301,  304,
      143,  305,  143,  306,  302,  143,  307,  308,  309,  143,
      310,  158,  273,  143,  311,  143,  303,  143,  361,  143,
      114,  312,  143,  304,  143,  305,  143,  143,  306,  143,

      307,  308,  309,  143,  158,  310,  273,  143,  311,  143,
      143,  313,  315,  143,  316,  312,  143,  317,  314,  314,
      318,  143,  319,  320,  320,  320,  323,  322,  159,  324,
      325,  326,  330,  321,  143,  313,  329,  315,  316,  164,
      143,  317,  161,  331,  108,  318,  319,  113,  143,  143,
      323,  159,  322,  324,  332,  325,  326,  330,  334,  143,
      329,  320,  320,  320,  143,  333,  143,  331,  143,  336,
      337,  321,  143,  143,  335,  108,  143,  338,  341,  332,
      347,  106,  334,  143,  348,  143,  143,  408,  408,  333,
      143,  408,  143,  408,  336,  337,  339,  339,  339,  335,

      143,  338,  341,  346,  347,  143,  340,  349,  348,  143,
      143,  342,  342,  342,  320,  320,  320,  344,  344,  344,
      408,  343,  352,  357,  321,  359,  143,  345,  346,  143,
      353,  349,  339,  339,  339,  342,  342,  342,  344,  344,
      344,  408,  340,  408,  143,  343,  352,  357,  345,  359,
      143,  143,  408,  143,  354,  353,  143,  355,  408,  143,
      356,  339,  339,  339,  342,  342,  342,  360,  143,  362,
      408,  340,  143,  363,  343,  143,  143,  143,  354,  143,
      143,  355,  143,  143,  356,  344,  344,  344,  364,  366,
      408,  367,  360,  368,  362,  345,  143,  363,  143,  143,

      143,  143,  378,  143,  365,  371,  143,  369,  369,  369,
      372,  372,  372,  364,  366,  367,  379,  370,  368,  408,
      373,  376,  143,  143,  408,  143,  378,  365,  408,  143,
      371,  374,  374,  374,  369,  369,  369,  372,  372,  372,
      379,  375,  408,  381,  370,  408,  376,  373,  374,  374,
      374,  408,  382,  143,  369,  369,  369,  383,  375,  372,
      372,  372,  384,  388,  370,  374,  374,  374,  381,  373,
      380,  386,  391,  387,  143,  375,  143,  382,  143,  143,
      395,  143,  383,  389,  393,  390,  408,  384,  388,  394,
      408,  408,  143,  143,  380,  386,  391,  387,  143,  397,

      143,  143,  143,  143,  395,  143,  399,  392,  389,  393,
      390,  143,  401,  402,  394,  396,  143,  143,  143,  143,
      398,  400,  403,  397,  404,  143,  143,  405,  143,  407,
      399,  392,  406,  143,  408,  143,  143,  401,  402,  396,
      408,  408,  143,  143,  398,  400,  408,  403,  408,  404,
      143,  405,  143,  408,  408,  408,  406,  143,  408,  408,
      143,  408,  408,  143,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  143,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,

       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,  104,  408,  408,  408,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  105,  105,  105,  105,  105,  105,  105,  105,

      105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
      105,  105,  105,  105,  105,  105,  105,  105,  107,  107,
      107,  107,  107,  107,  107,  109,  109,  408,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
      109,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
      112,  112,  112,  112,  112,  112,  112,  114,  114,  114,
      408,  114,  114,  408,  114,  408,  408,  114,  114,  114,
      114,  114,  114,  114,  114,  115,  115,  408,  408,  408,

      408,  115,  115,  115,  115,  115,  115,  115,  130,  408,
      130,  408,  408,  408,  130,  130,  408,  130,  408,  408,
      408,  130,  408,  408,  408,  130,  130,  130,  130,  130,
      130,  130,  133,  408,  133,  408,  133,  133,  408,  408,
      408,  408,  408,  133,  133,  133,  133,  133,  133,  133,
      136,  408,  408,  136,  136,  136,  136,  136,  408,  408,
      408,  136,  136,  136,  136,  136,  136,  136,  137,  137,
      408,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  140,  408,  408,  408,  140,  408,

      140,  140,  408,  408,  408,  408,  140,  140,  140,  140,
      140,  140,  140,  143,  143,  143,  143,  143,  143,  143,
      408,  143,  408,  408,  143,  143,  143,  143,  143,  143,
      143,  143,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  162,  162,  162,  408,  408,  408,
      408,  162,  162,  162,  162,  162,  162,  162,  162,  163,

      163,  163,  163,  163,  163,  163,  408,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  166,  408,  408,  408,  166,
      166,  166,  166,  166,  166,  166,  166,  166,  166,  166,
      166,  166,  166,  166,  166,  166,  166,  166,  166,  166,
      166,  169,  169,  169,  169,  169,  169,  408,  169,  169,
      169,  169,  169,  169,  169,  169,  169,  169,  169,  169,
      169,  169,  169,  169,  169,  169,  169,  173,  408,  173,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  173,  173,  173,  173,  173,  173,  173,  174,  174,

      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  185,  185,  408,  408,  408,  408,
      185,  185,  185,  185,  185,  185,  185,  185,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  204,  204,  408,  204,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      139,  408,  408,  408,  139,  408,  408,  408,  408,  408,

      408,  408,  139,  139,  139,  139,  139,  139,  139,  219,
      408,  408,  219,  408,  219,  408,  219,  219,  408,  408,
      219,  219,  408,  219,  219,  219,  219,  219,  219,  219,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  140,  408,  408,  408,
      408,  408,  140,  140,  408,  140,  140,  140,  408,  408,
      408,  140,  140,  140,  140,  140,  140,  140,  225,  408,
      408,  225,  225,  225,  225,  225,  225,  225,  408,  225,
      225,  408,  225,  225,  225,  225,  225,  225,  225,  225,

      143,  143,  143,  143,  143,  143,  143,  408,  143,  408,
      408,  143,  143,  143,  143,  143,  143,  143,  143,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  408,  408,  408,  408,
      408,  408,  157,  408,  408,  408,  408,  157,  157,  157,
      408,  408,  157,  157,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  160,  160,
      162,  162,  162,  408,  408,  408,  408,  162,  162,  162,

      162,  162,  162,  162,  162,  163,  163,  163,  163,  163,
      163,  163,  408,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      163,  166,  408,  408,  408,  166,  166,  166,  166,  166,
      166,  166,  166,  166,  166,  166,  166,  166,  166,  166,
      166,  166,  166,  166,  166,  166,  166,  169,  169,  169,
      169,  169,  169,  408,  169,  169,  169,  169,  169,  169,
      169,  169,  169,  169,  169,  169,  169,  169,  169,  169,
      169,  169,  169,  169,  169,  408,  408,  408,  408,  408,
      169,  408,  408,  408,  408,  408,  408,  169,  408,  408,

      169,  408,  169,  173,  173,  173,  173,  173,  173,  173,
      242,  408,  408,  408,  408,  408,  242,  242,  242,  242,
      408,  408,  408,  408,  242,  242,  242,  242,  242,  242,
      242,  242,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
      408,  408,  408,  408,  408,  174,  408,  408,  408,  408,
      408,  408,  174,  408,  408,  174,  408,  174,  245,  408,
      408,  408,  408,  408,  245,  245,  245,  185,  185,  408,
      408,  408,  408,  185,  185,  185,  185,  185,  185,  185,

      185,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
      251,  251,  251,  109,  109,  109,  109,  109,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
      109,  109,  109,  109,  109,  109,  109,  109,  109,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
      253,  253,  253,  253,  253,  253,  253,  253,  253,  253,

      253,  253,  253,  253,  253,  254,  254,  408,  254,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
      254,  255,  255,  408,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
      255,  255,  255,  255,  255,  255,  255,  204,  204,  408,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  256,  256,  408,  256,  256,  256,  256,
      256,  256,  256,  256,  256,  256,  256,  256,  256,  256,

      256,  256,  256,  256,  256,  256,  256,  256,  256,  114,
      114,  114,  408,  114,  114,  408,  114,  408,  408,  114,
      114,  114,  114,  114,  114,  114,  114,  219,  408,  408,
      219,  408,  219,  408,  219,  219,  408,  408,  219,  219,
      408,  219,  219,  219,  219,  219,  219,  219,  271,  271,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  271,  271,  271,  271,  271,  271,  271,
      225,  408,  408,  225,  225,  225,  225,  225,  225,  225,
      408,  225,  225,  408,  225,  225,  225,  225,  225,  225,
      225,  225,  143,  143,  143,  143,  143,  143,  143,  408,

      143,  408,  408,  143,  143,  143,  143,  143,  143,  143,
      143,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  157,  157,  157,
      157,  157,  157,  157,  157,  157,  157,  286,  286,  408,
      408,  408,  408,  286,  286,  286,  288,  288,  408,  408,
      408,  408,  288,  288,  288,  169,  169,  408,  408,  408,
      408,  169,  169,  169,  174,  174,  408,  408,  408,  408,
      174,  174,  174,  350,  350,  408,  350,  350,  350,  350,
      350,  350,  350,  350,  350,  350,  350,  350,  350,  350,
      350,  350,  350,  350,  350,  350,  350,  350,  350,   13,

      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408
    } ;

static yyconst flex_int16_t yy_chk[2979] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    5,    6,    7,    7,    7,    8,
        8,    8,    9,   23,  405,    5,    6,   10,   23,    9,
        9,    9,   94,   94,   10,   10,   10,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   28,   83,   29,   30,   31,
       32,  382,   33,   34,   35,   36,  111,   32,   37,   43,
       38,   43,   50,   43,   43,   50,   51,  111,   36,   51,
       28,   29,   30,   31,  103,   32,   33,   34,   35,   53,
       36,   32,   46,   37,   38,   42,   50,   42,   83,   50,
       51,   46,   36,   51,   46,   46,   46,  139,   42,  103,
       42,  139,   54,   53,   54,   62,   42,   45,   45,  139,

       45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
       45,   45,   45,   79,   80,   45,   54,   80,   54,  367,
       45,   45,   45,   45,   45,   45,   48,   48,   48,   48,
       48,   52,   48,   48,   48,   55,   48,  351,   52,   52,
       55,   97,   62,   58,   58,   74,   74,   74,  157,   45,
       45,   92,   92,   92,  159,  159,   52,   91,   91,   55,
       79,   57,   52,   52,   55,   97,   48,   58,   58,  350,
       57,   56,   45,   45,   45,   47,   47,   47,   47,   47,
       56,   47,   47,   47,   56,   47,   57,  328,   91,   99,
      100,  253,  101,   47,   57,  157,   56,  104,  104,  104,

      102,  108,  108,  108,   56,  303,  108,  303,   56,  116,
      117,   91,  118,   99,  100,   47,  101,  119,   47,   49,
       49,   49,   49,   49,  102,   49,   49,   49,  121,   49,
      110,  110,  110,  116,  117,  110,  118,  122,  123,  251,
      124,  119,  125,  126,  127,  128,  148,  123,   49,  130,
      201,  130,  121,  130,  130,  327,  133,  327,  133,   49,
      133,  133,  122,  123,  124,  199,  125,  126,  127,  128,
      148,  123,   49,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,

      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  129,  135,  129,  135,  194,  135,  135,  136,  136,
      136,  178,  178,  142,  129,  142,  129,  142,  142,  174,
      136,  153,  129,  137,  137,  137,  137,  137,  137,  137,
      137,  137,  137,  137,  137,  137,  137,  137,  137,  145,
      140,  137,  146,  146,  145,  153,  137,  137,  137,  137,

      137,  137,  140,  140,  169,  164,  140,  140,  140,  140,
      141,  174,  223,  145,  224,  224,  146,  146,  145,  141,
      141,  152,  141,  141,  223,  137,  137,  141,  152,  186,
      150,  141,  143,  143,  143,  143,  143,  147,  143,  143,
      143,  147,  143,  149,  150,  152,  149,  187,  137,  137,
      137,  169,  152,  151,  186,  150,  167,  167,  167,  141,
      154,  147,  151,  155,  154,  147,  151,  149,  150,  155,
      149,  187,  143,  144,  144,  144,  144,  144,  151,  144,
      144,  144,  190,  144,  154,  188,  151,  155,  154,  191,
      151,  156,  156,  155,  171,  171,  176,  176,  180,  180,

      180,  192,  192,  192,  206,  338,  144,  190,  163,  188,
      207,  210,  160,  144,  191,  156,  156,  197,  197,  197,
      208,  209,  197,  211,  214,  171,  138,  176,  338,  206,
      144,  198,  198,  198,  207,  210,  198,  200,  200,  200,
      240,  240,  200,  243,  243,  208,  209,  211,  171,  214,
      176,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,

      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  196,
      196,  196,  196,  196,  196,  196,  196,  196,  196,  212,
      213,  216,  217,  218,  220,  220,  220,  222,  222,  222,
      228,  132,  230,  131,  230,  115,  231,  105,  231,  229,
      225,  235,  228,  212,  213,  216,  217,  234,  218,  225,
      225,  238,  225,  225,  229,  228,  230,  225,  230,  234,
      231,  225,  231,  238,  229,  235,  228,  269,  269,  270,
      270,  247,  234,  285,  285,  232,  238,  232,  229,  233,
      236,  233,  236,  234,  237,  249,  237,  238,  250,  225,

      226,  226,  226,  226,  226,  247,  226,  226,  226,  232,
      226,  232,  239,  233,  236,  233,  236,  257,  237,  249,
      237,  258,  250,  260,  226,   96,  239,  239,  287,  287,
       95,  261,   90,   78,  271,  271,   69,  262,  263,  264,
      226,  257,  265,  267,  268,  258,  271,   68,  260,  226,
      227,  227,  227,  227,  227,  261,  227,  227,  227,  239,
      227,  262,  263,  274,  264,  347,  265,  267,  268,  272,
      273,  273,  272,  275,  302,  276,  276,  277,  278,  278,
      279,  314,  227,  277,  280,  281,  302,  274,  347,  275,
      227,  282,  279,  272,  273,  273,  272,  282,  275,  276,

      276,  277,  278,  278,  284,  279,  227,  277,  280,  281,
      283,  283,  289,  275,  290,  282,  279,  292,  284,  284,
      293,  282,  294,  295,  295,  295,  297,  296,  314,  298,
      299,  300,  305,  295,  283,  283,  304,  289,  290,   67,
      304,  292,   63,  306,   44,  293,  294,   25,  305,  306,
      297,  284,  296,  298,  308,  299,  300,  305,  310,  310,
      304,  307,  307,  307,  304,  309,  308,  306,  309,  312,
      315,  307,  305,  306,  311,   22,  313,  316,  318,  308,
      324,   18,  310,  310,  325,  312,  311,   13,    0,  309,
      308,    0,  309,    0,  312,  315,  317,  317,  317,  311,

      313,  316,  318,  323,  324,  307,  317,  326,  325,  312,
      311,  319,  319,  319,  320,  320,  320,  322,  322,  322,
        0,  319,  330,  337,  320,  341,  330,  322,  323,  307,
      333,  326,  329,  329,  329,  331,  331,  331,  332,  332,
      332,    0,  329,    0,  333,  331,  330,  337,  332,  341,
      330,  355,    0,  334,  334,  333,  335,  335,    0,  336,
      336,  339,  339,  339,  342,  342,  342,  346,  333,  349,
        0,  339,  352,  352,  342,  355,  329,  334,  334,  331,
      335,  335,  332,  336,  336,  344,  344,  344,  353,  356,
        0,  357,  346,  358,  349,  344,  352,  352,  354,  353,

      329,  356,  368,  331,  354,  360,  332,  359,  359,  359,
      361,  361,  361,  353,  356,  357,  371,  359,  358,    0,
      361,  364,  354,  353,    0,  356,  368,  354,    0,  364,
      360,  362,  362,  362,  363,  363,  363,  365,  365,  365,
      371,  362,    0,  377,  363,    0,  364,  365,  366,  366,
      366,    0,  378,  364,  369,  369,  369,  379,  366,  372,
      372,  372,  380,  385,  369,  374,  374,  374,  377,  372,
      376,  383,  389,  384,  380,  374,  376,  378,  363,  384,
      393,  365,  379,  386,  391,  387,    0,  380,  385,  392,
        0,    0,  366,  387,  376,  383,  389,  384,  380,  395,

      376,  392,  363,  384,  393,  365,  397,  390,  386,  391,
      387,  390,  399,  400,  392,  394,  366,  387,  396,  394,
      396,  398,  401,  395,  402,  392,  398,  403,  400,  406,
      397,  390,  404,  404,    0,  390,  402,  399,  400,  394,
        0,    0,  396,  394,  396,  398,    0,  401,    0,  402,
      398,  403,  400,    0,    0,    0,  404,  404,    0,    0,
      402,    0,    0,  406,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  406,  409,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  409,  409,

      409,  409,  409,  409,  409,  409,  409,  409,  409,  409,
      409,  409,  409,  409,  410,  410,  410,  410,  410,  410,
      410,  410,  410,  410,  410,  410,  410,  410,  410,  410,
      410,  410,  410,  410,  410,  410,  410,  410,  410,  410,
      411,  411,  411,  411,  411,  411,  411,  411,  411,  411,
      411,  411,  411,  411,  411,  411,  411,  411,  411,  411,
      411,  411,  411,  411,  411,  411,  412,    0,    0,    0,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  413,  413,  413,  413,  413,  413,  413,  413,

      413,  413,  413,  413,  413,  413,  413,  413,  413,  413,
      413,  413,  413,  413,  413,  413,  413,  413,  414,  414,
      414,  414,  414,  414,  414,  415,  415,    0,  415,  415,
      415,  415,  415,  415,  415,  415,  415,  415,  415,  415,
      415,  415,  415,  415,  415,  415,  415,  415,  415,  415,
      415,  416,  416,  416,  416,  416,  416,  416,  416,  416,
      416,  416,  416,  416,  416,  416,  416,  416,  416,  416,
      416,  416,  416,  416,  416,  416,  416,  417,  417,  417,
        0,  417,  417,    0,  417,    0,    0,  417,  417,  417,
      417,  417,  417,  417,  417,  418,  418,    0,    0,    0,

        0,  418,  418,  418,  418,  418,  418,  418,  419,    0,
      419,    0,    0,    0,  419,  419,    0,  419,    0,    0,
        0,  419,    0,    0,    0,  419,  419,  419,  419,  419,
      419,  419,  420,    0,  420,    0,  420,  420,    0,    0,
        0,    0,    0,  420,  420,  420,  420,  420,  420,  420,
      421,    0,    0,  421,  421,  421,  421,  421,    0,    0,
        0,  421,  421,  421,  421,  421,  421,  421,  422,  422,
        0,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  423,    0,    0,    0,  423,    0,

      423,  423,    0,    0,    0,    0,  423,  423,  423,  423,
      423,  423,  423,  424,  424,  424,  424,  424,  424,  424,
        0,  424,    0,    0,  424,  424,  424,  424,  424,  424,
      424,  424,  425,  425,  425,  425,  425,  425,  425,  425,
      425,  425,  425,  425,  425,  425,  425,  425,  425,  425,
      425,  425,  425,  425,  425,  425,  425,  425,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,
      426,  426,  426,  426,  427,  427,  427,    0,    0,    0,
        0,  427,  427,  427,  427,  427,  427,  427,  427,  428,

      428,  428,  428,  428,  428,  428,    0,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  429,    0,    0,    0,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  430,  430,  430,  430,  430,  430,    0,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  430,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  431,    0,  431,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,  431,  431,  431,  431,  431,  431,  431,  432,  432,

      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  433,  433,    0,    0,    0,    0,
      433,  433,  433,  433,  433,  433,  433,  433,  434,  434,
      434,  434,  434,  434,  434,  434,  434,  434,  434,  434,
      434,  434,  434,  434,  434,  434,  434,  434,  434,  434,
      434,  434,  434,  434,  435,  435,    0,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      436,    0,    0,    0,  436,    0,    0,    0,    0,    0,

        0,    0,  436,  436,  436,  436,  436,  436,  436,  437,
        0,    0,  437,    0,  437,    0,  437,  437,    0,    0,
      437,  437,    0,  437,  437,  437,  437,  437,  437,  437,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  439,    0,    0,    0,
        0,    0,  439,  439,    0,  439,  439,  439,    0,    0,
        0,  439,  439,  439,  439,  439,  439,  439,  440,    0,
        0,  440,  440,  440,  440,  440,  440,  440,    0,  440,
      440,    0,  440,  440,  440,  440,  440,  440,  440,  440,

      441,  441,  441,  441,  441,  441,  441,    0,  441,    0,
        0,  441,  441,  441,  441,  441,  441,  441,  441,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  443,    0,    0,    0,    0,
        0,    0,  443,    0,    0,    0,    0,  443,  443,  443,
        0,    0,  443,  443,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      445,  445,  445,    0,    0,    0,    0,  445,  445,  445,

      445,  445,  445,  445,  445,  446,  446,  446,  446,  446,
      446,  446,    0,  446,  446,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  447,    0,    0,    0,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  448,  448,  448,
      448,  448,  448,    0,  448,  448,  448,  448,  448,  448,
      448,  448,  448,  448,  448,  448,  448,  448,  448,  448,
      448,  448,  448,  449,  449,    0,    0,    0,    0,    0,
      449,    0,    0,    0,    0,    0,    0,  449,    0,    0,

      449,    0,  449,  450,  450,  450,  450,  450,  450,  450,
      451,    0,    0,    0,    0,    0,  451,  451,  451,  451,
        0,    0,    0,    0,  451,  451,  451,  451,  451,  451,
      451,  451,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  452,  453,  453,
        0,    0,    0,    0,    0,  453,    0,    0,    0,    0,
        0,    0,  453,    0,    0,  453,    0,  453,  454,    0,
        0,    0,    0,    0,  454,  454,  454,  455,  455,    0,
        0,    0,    0,  455,  455,  455,  455,  455,  455,  455,

      455,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  458,  458,  458,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  458,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,

      459,  459,  459,  459,  459,  460,  460,    0,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  461,  461,    0,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  462,  462,    0,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
      462,  462,  462,  463,  463,    0,  463,  463,  463,  463,
      463,  463,  463,  463,  463,  463,  463,  463,  463,  463,

      463,  463,  463,  463,  463,  463,  463,  463,  463,  464,
      464,  464,    0,  464,  464,    0,  464,    0,    0,  464,
      464,  464,  464,  464,  464,  464,  464,  465,    0,    0,
      465,    0,  465,    0,  465,  465,    0,    0,  465,  465,
        0,  465,  465,  465,  465,  465,  465,  465,  466,  466,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  466,  466,  466,  466,  466,  466,  466,
      467,    0,    0,  467,  467,  467,  467,  467,  467,  467,
        0,  467,  467,    0,  467,  467,  467,  467,  467,  467,
      467,  467,  468,  468,  468,  468,  468,  468,  468,    0,

      468,    0,    0,  468,  468,  468,  468,  468,  468,  468,
      468,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  470,  470,    0,
        0,    0,    0,  470,  470,  470,  471,  471,    0,    0,
        0,    0,  471,  471,  471,  472,  472,    0,    0,    0,
        0,  472,  472,  472,  473,  473,    0,    0,    0,    0,
      473,  473,  473,  474,  474,    0,  474,  474,  474,  474,
      474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
      474,  474,  474,  474,  474,  474,  474,  474,  474,  408,

      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[87] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 
    0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 
    1, 1, 0, 1, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2012 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* The rsyslog runtime library is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* The rsyslog runtime library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with the rsyslog runtime library.  If not, see <http://www.gnu.org/licenses/>.
*
* A copy of the GPL can be found in the file "COPYING" in this distribution.
* A copy of the LGPL can be found in the file "COPYING.LESSER" in this distribution.
*/
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 61 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
//char *strdup(char*);
int fileno(FILE *stream);

#line 1374 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define EXPR 5

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 94 "lexer.l"


 /* keywords */
#line 1571 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 409 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2900 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 97 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 98 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 99 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 100 "lexer.l"
{ return OR; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 101 "lexer.l"
{ return AND; }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 102 "lexer.l"
{ return NOT; }
	YY_BREAK
case 7:
#line 104 "lexer.l"
case 8:
#line 105 "lexer.l"
case 9:
#line 106 "lexer.l"
case 10:
#line 107 "lexer.l"
case 11:
#line 108 "lexer.l"
case 12:
#line 109 "lexer.l"
case 13:
#line 110 "lexer.l"
case 14:
#line 111 "lexer.l"
case 15:
#line 112 "lexer.l"
case 16:
YY_RULE_SETUP
#line 112 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 113 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 114 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 115 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 20:
#line 117 "lexer.l"
case 21:
YY_RULE_SETUP
#line 117 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 118 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 119 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 120 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 121 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 122 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 123 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 28:
#line 125 "lexer.l"
case 29:
#line 126 "lexer.l"
case 30:
YY_RULE_SETUP
#line 126 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 127 "lexer.l"
{ yylval.s = strdup(yytext); return VAR; }
	YY_BREAK
case 32:
/* rule 32 can match eol */
YY_RULE_SETUP
#line 128 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 33:
/* rule 33 can match eol */
YY_RULE_SETUP
#line 133 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 34:
/* rule 34 can match eol */
YY_RULE_SETUP
#line 138 "lexer.l"

	YY_BREAK
case 35:
YY_RULE_SETUP
#line 139 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 141 "lexer.l"
{ dbgprintf("invalid char in expr: %s\n", yytext); }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 142 "lexer.l"
{ return '&'; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 143 "lexer.l"
{ return '{'; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 144 "lexer.l"
{ return '}'; }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 145 "lexer.l"
{ dbgprintf("RULESET\n"); }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 41:
YY_RULE_SETUP
#line 149 "lexer.l"
{ return STOP; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 150 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 151 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 152 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 153 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 154 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 155 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
#line 156 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 160 "lexer.l"

	YY_BREAK
case 50:
YY_RULE_SETUP
#line 161 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 164 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 166 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 168 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 170 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 172 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
#line 174 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
#line 176 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 177 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext)); return PROPFILT; }
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 179 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 60:
#line 181 "lexer.l"
case 61:
#line 182 "lexer.l"
case 62:
/* rule 62 can match eol */
#line 183 "lexer.l"
case 63:
/* rule 63 can match eol */
#line 184 "lexer.l"
case 64:
/* rule 64 can match eol */
#line 185 "lexer.l"
case 65:
/* rule 65 can match eol */
#line 186 "lexer.l"
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 186 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 187 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 188 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 190 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 191 "lexer.l"
{
				  yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 194 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 195 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 196 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 197 "lexer.l"

	YY_BREAK
case 75:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 198 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 199 "lexer.l"

	YY_BREAK
case 77:
YY_RULE_SETUP
#line 200 "lexer.l"
{ dbgprintf("INOBJ: invalid char '%s'\n", yytext); }
	YY_BREAK
case 78:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 201 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 79:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 212 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 80:
/* rule 80 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 213 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 81:
/* rule 81 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 214 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 82:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 215 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 216 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 217 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 218 "lexer.l"
{ dbgprintf("invalid char: %s\n", yytext);
				}
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(EXPR):
#line 220 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 222 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2130 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 409 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 409 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 408);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 222 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL)
		return 1; /* all processed */
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

